package com.ruoyi.postCheck.controller;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.postCheck.domain.homePage.AssessmentRatingView;
import com.ruoyi.postCheck.domain.homePage.DeptProblemRectificationView;
import com.ruoyi.postCheck.domain.homePage.PostCheckedProblemView;
import com.ruoyi.postCheck.domain.homePage.PostCheckedUnCheckedView;
import com.ruoyi.postCheck.domain.problemStatistics.*;
import com.ruoyi.postCheck.service.IPostCheckedProblemService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.math.BigDecimal;
import java.util.*;

/**
 * 岗检问题表Controller
 *
 * @author csg
 * @date 2023-12-23
 */
@Api(tags = "5.1.1-统计分析-检查统计-问题统计（职能管理）")
@RestController
@RequestMapping("/postCheck/functionProblemStatistics")
public class PostCheckedFunctionProblemStatisticsController extends BaseController {
    @Autowired
    private IPostCheckedProblemService postCheckedProblemService;


    @ApiOperation("1-职能部各部门问题数量对比")
    @GetMapping("/functionDeptProblemContrast")
//    @ApiImplicitParam(name = "notParam", value = "V2方便接口联调-这是返回信息", dataType = "FunctionDeptProblemContrastView", dataTypeClass = FunctionDeptProblemContrastView.class)
    public AjaxResult functionDeptProblemContrast() { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        GROUP BY problem_attribute -- 问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）
//        GROUP BY problem_category -- 问题类别（职责权限问题、工作内容问题、工作标准问题、考核奖励问题、任职资格问题、其他）
        List<FunctionDeptProblemContrastView> list = new ArrayList<>();

        Integer type = 1;
        List<Map<String, Object>> deptIdListByType = postCheckedProblemService.getDeptIdListByType(type);
        if (deptIdListByType!=null && deptIdListByType.size()>0){
            for (Map<String, Object> map : deptIdListByType) {
                FunctionDeptProblemContrastView data = new FunctionDeptProblemContrastView();
                data.setDeptId(Long.parseLong(map.get("deptId").toString()));
                data.setDeptName(String.valueOf(map.get("deptName")));
                postCheckedProblemService.functionDeptProblemContrast(data);
                list.add(data);
            }
        }

        return success(list);
    }


    @ApiOperation("2-岗检覆盖率")
    @GetMapping("/coverageRateView")
    public AjaxResult coverageRateView(CoverageRateView notParam) { //notParam不是参数-是返回信息-方便接口联调
        Integer type = 1;
        return success(postCheckedProblemService.coverageRateView(type));
    }

    @ApiOperation("3-岗检问题职责类别占比")
    @GetMapping("/dutyTypeProblemStatisticsView")
    public AjaxResult dutyTypeProblemStatisticsView(DutyTypeProblemStatisticsView notParam) { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        group by duty_type 职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；


        Integer type = 1;
        return success(postCheckedProblemService.dutyTypeProblemStatisticsView(type));
    }

    @ApiOperation("4-岗检问题级别占比")
    @GetMapping("/problemLevelView")
    public AjaxResult problemLevelView(ProblemLevelView notParam) { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        group by problem_level   问题等级（一般、重要）

        Integer type = 1;
        return success(postCheckedProblemService.problemLevelView(type));
    }


    @ApiOperation("5-岗检问题属性及类别整改占比")
    @GetMapping("/problemAttributeCategoryView")
    public AjaxResult problemAttributeCategoryView(ProblemAttributeCategoryView notParam) { //notParam不是参数-是返回信息-方便接口联调

        Integer type = 1;
        return success(postCheckedProblemService.problemAttributeCategoryView(type));
    }


    @ApiOperation("6-历年岗检问题数量")
    @GetMapping("/historyProblemNumberView")
    public AjaxResult historyProblemNumberView(HistoryProblemNumberView notParam) { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        GROUP BY problem_attribute -- 问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）
//        GROUP BY problem_category -- 问题类别（职责权限问题、工作内容问题、工作标准问题、考核奖励问题、任职资格问题、其他）


        List<HistoryProblemNumberView> list = new ArrayList<>();
        HistoryProblemNumberView data = new HistoryProblemNumberView();
        data.setCheckYear(new Date());
//        data.set问题总数
//        data.set完成性
//        data.set适宜性
//        data.set有效性
//        data.set职责权限
//        data.set工作内容
//        data.set工作标准
//        data.set考核奖励
//        data.set任职资格
//        data.set其他

        list.add(data);
        return success(list);
    }

/*
    @ApiOperation("7-部门详情")
    @GetMapping("/deptDetaailView")
    public AjaxResult deptDetaailView() {
//         查询问题表
//        select * from "public"."post_checked_problem";
//        group by duty_type 职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；
//        GROUP BY problem_attribute -- 问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）


        List<DeptDetaailView> list = new ArrayList<>();

        //TODO 第一步：得到4个职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；
        //TODO 第二步：遍历职责类别 -> （总数和已完成数）设置问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）
        DeptDetaailView data1 = new DeptDetaailView();
//        data4.setdutyTypeOne //业务职责
        List<DeptDetaailView.ProblemAttributeInner> children1 = new ArrayList<>();
        DeptDetaailView.ProblemAttributeInner child1 = new DeptDetaailView.ProblemAttributeInner();
//        child1.set完整性数量") private Integer problemComplete;
//        child1.set适宜性数量") private Integer problemSuitable;
//        child1.set有效性数量") private Integer problemEffective;
//        child1.set已完成完整性数量") private Integer problemCompleteChecked;
//        child1.set已完成适宜性数量") private Integer problemSuitableChecked;
//        child1.set已完成有效性数量") private Integer problemEffectiveChecked;
        children1.add(child1);
        data1.setChildren(children1);
        list.add(data1);

        DeptDetaailView data2 = new DeptDetaailView();
//        data4.setdutyTypeTwo 党建及党风廉政
        List<DeptDetaailView.ProblemAttributeInner> children2 = new ArrayList<>();
        DeptDetaailView.ProblemAttributeInner child2 = new DeptDetaailView.ProblemAttributeInner();
//        child2.set完整性数量") private Integer problemComplete;
//        child2.set适宜性数量") private Integer problemSuitable;
//        child2.set有效性数量") private Integer problemEffective;
//        child2.set已完成完整性数量") private Integer problemCompleteChecked;
//        child2.set已完成适宜性数量") private Integer problemSuitableChecked;
//        child2.set已完成有效性数量") private Integer problemEffectiveChecked;
        children1.add(child2);
        data2.setChildren(children2);
        list.add(data2);

        DeptDetaailView data3 = new DeptDetaailView();
//        data4.setdutyTypeThree 安全环保职责
        List<DeptDetaailView.ProblemAttributeInner> children3 = new ArrayList<>();
        DeptDetaailView.ProblemAttributeInner child3 = new DeptDetaailView.ProblemAttributeInner();
//        child3.set完整性数量") private Integer problemComplete;
//        child3.set适宜性数量") private Integer problemSuitable;
//        child3.set有效性数量") private Integer problemEffective;
//        child3.set已完成完整性数量") private Integer problemCompleteChecked;
//        child3.set已完成适宜性数量") private Integer problemSuitableChecked;
//        child3.set已完成有效性数量") private Integer problemEffectiveChecked;
        children1.add(child3);
        data3.setChildren(children3);
        list.add(data3);

        DeptDetaailView data4 = new DeptDetaailView();
//        data4.setdutyTypeFour 合规保密职
        List<DeptDetaailView.ProblemAttributeInner> children4 = new ArrayList<>();
        DeptDetaailView.ProblemAttributeInner child4 = new DeptDetaailView.ProblemAttributeInner();
//        child4.set完整性数量") private Integer problemComplete;
//        child4.set适宜性数量") private Integer problemSuitable;
//        child4.set有效性数量") private Integer problemEffective;
//        child4.set已完成完整性数量") private Integer problemCompleteChecked;
//        child4.set已完成适宜性数量") private Integer problemSuitableChecked;
//        child4.set已完成有效性数量") private Integer problemEffectiveChecked;
        children1.add(child4);
        data4.setChildren(children4);
        list.add(data4);
        return success(list);
    }
    */
}
